/********************************************************************************

Copyright: Acclaim Systems Ltd 2004
Author:    rskinner
 
No claims are made concerning the suitability of this source code for any purpose. 
All source is provided 'as is' without express or implied warranty of any kind.
Acclaim Systems Ltd disclaims any/all implied warranties of merchantability, 
non-infringement or fitness for any particular purpose. In no event will Acclaim
Systems Ltd be liable for any special, indirect, incidental, consequential or 
any other damages resulting from loss of use, data or profits arising out of or 
in connection with the use or performance of this source code.

License:   Free to use and abuse for non-profit activities so long as the 
           attribution and disclaimer above are not altered. For-profit use 
           is prohibited without express written permission.
 
*******************************************************************************/

#ifndef H2D_D_H
#define H2D_D_H

#include "h2d.h"

// All the D types...

namespace h2d {

  struct DTypesGrammar : public boost::spirit::grammar<DTypesGrammar> {

    template<typename T>
    struct definition {

      typedef boost::spirit::rule<T> rule_t;

      definition(DTypesGrammar const& self) {

        rule_ = 
          str_p("wchar") |
          str_p("dchar") |
          str_p("char") |
          str_p("ulong") |
          str_p("long") |
          str_p("uint") |
          str_p("int") |
          str_p("ushort") |
          str_p("short") |
          str_p("bit") |
          str_p("ubyte") |
          str_p("byte") |
          str_p("void") |
          str_p("ucent") |
          str_p("cent") |
          str_p("float") |
          str_p("double") |
          str_p("real") |
          str_p("ireal") |
          str_p("ifloat") |
          str_p("idouble") |
          str_p("creal") |
          str_p("cfloat") |
          str_p("cdouble");
      }

      rule_t const& start() const { return rule_; }
    private:
      rule_t rule_;
    };
  };
}

#endif
